/*
 * generated by Xtext 2.13.0
 */
package com.javadude.dsl5.ide.contentassist.antlr;

import com.google.inject.Inject;
import com.javadude.dsl5.ide.contentassist.antlr.internal.InternalGothicSecurityDslParser;
import com.javadude.dsl5.services.GothicSecurityDslGrammarAccess;
import java.util.HashMap;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;

public class GothicSecurityDslParser extends AbstractContentAssistParser {

	@Inject
	private GothicSecurityDslGrammarAccess grammarAccess;

	private Map<AbstractElement, String> nameMappings;

	@Override
	protected InternalGothicSecurityDslParser createParser() {
		InternalGothicSecurityDslParser result = new InternalGothicSecurityDslParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		if (nameMappings == null) {
			nameMappings = new HashMap<AbstractElement, String>() {
				private static final long serialVersionUID = 1L;
				{
					put(grammarAccess.getStateMachineAccess().getGroup(), "rule__StateMachine__Group__0");
					put(grammarAccess.getCommandAccess().getGroup(), "rule__Command__Group__0");
					put(grammarAccess.getEventAccess().getGroup(), "rule__Event__Group__0");
					put(grammarAccess.getStateAccess().getGroup(), "rule__State__Group__0");
					put(grammarAccess.getActionAccess().getGroup(), "rule__Action__Group__0");
					put(grammarAccess.getTransitionAccess().getGroup(), "rule__Transition__Group__0");
					put(grammarAccess.getResetAccess().getGroup(), "rule__Reset__Group__0");
					put(grammarAccess.getTestAccess().getGroup(), "rule__Test__Group__0");
					put(grammarAccess.getStateMachineAccess().getNameAssignment_1(), "rule__StateMachine__NameAssignment_1");
					put(grammarAccess.getStateMachineAccess().getStartStateAssignment_4(), "rule__StateMachine__StartStateAssignment_4");
					put(grammarAccess.getStateMachineAccess().getCommandsAssignment_5(), "rule__StateMachine__CommandsAssignment_5");
					put(grammarAccess.getStateMachineAccess().getEventsAssignment_6(), "rule__StateMachine__EventsAssignment_6");
					put(grammarAccess.getStateMachineAccess().getStatesAssignment_7(), "rule__StateMachine__StatesAssignment_7");
					put(grammarAccess.getStateMachineAccess().getResetEventsAssignment_8(), "rule__StateMachine__ResetEventsAssignment_8");
					put(grammarAccess.getStateMachineAccess().getTestsAssignment_9(), "rule__StateMachine__TestsAssignment_9");
					put(grammarAccess.getCommandAccess().getNameAssignment_1(), "rule__Command__NameAssignment_1");
					put(grammarAccess.getCommandAccess().getCodeAssignment_3(), "rule__Command__CodeAssignment_3");
					put(grammarAccess.getEventAccess().getNameAssignment_1(), "rule__Event__NameAssignment_1");
					put(grammarAccess.getEventAccess().getCodeAssignment_3(), "rule__Event__CodeAssignment_3");
					put(grammarAccess.getStateAccess().getNameAssignment_1(), "rule__State__NameAssignment_1");
					put(grammarAccess.getStateAccess().getActionsAssignment_3(), "rule__State__ActionsAssignment_3");
					put(grammarAccess.getStateAccess().getTransitionsAssignment_4(), "rule__State__TransitionsAssignment_4");
					put(grammarAccess.getActionAccess().getCommandAssignment_1(), "rule__Action__CommandAssignment_1");
					put(grammarAccess.getTransitionAccess().getEventAssignment_1(), "rule__Transition__EventAssignment_1");
					put(grammarAccess.getTransitionAccess().getTargetAssignment_4(), "rule__Transition__TargetAssignment_4");
					put(grammarAccess.getResetAccess().getEventAssignment_2(), "rule__Reset__EventAssignment_2");
					put(grammarAccess.getTestAccess().getNameAssignment_1(), "rule__Test__NameAssignment_1");
					put(grammarAccess.getTestAccess().getEventsAssignment_3(), "rule__Test__EventsAssignment_3");
				}
			};
		}
		return nameMappings.get(element);
	}
			
	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public GothicSecurityDslGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(GothicSecurityDslGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
}
